# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.224
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class BatchUpsertPortfolioAccessMetadataResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'portfolios_with_metadata': 'dict(str, MetadataKeyValueResponse)'
    }

    attribute_map = {
        'portfolios_with_metadata': 'portfoliosWithMetadata'
    }

    required_map = {
        'portfolios_with_metadata': 'required'
    }

    def __init__(self, portfolios_with_metadata=None, local_vars_configuration=None):  # noqa: E501
        """BatchUpsertPortfolioAccessMetadataResponse - a model defined in OpenAPI"
        
        :param portfolios_with_metadata:  The set of portfolios with the access control metadata (required)
        :type portfolios_with_metadata: dict[str, lusid.MetadataKeyValueResponse]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._portfolios_with_metadata = None
        self.discriminator = None

        self.portfolios_with_metadata = portfolios_with_metadata

    @property
    def portfolios_with_metadata(self):
        """Gets the portfolios_with_metadata of this BatchUpsertPortfolioAccessMetadataResponse.  # noqa: E501

        The set of portfolios with the access control metadata  # noqa: E501

        :return: The portfolios_with_metadata of this BatchUpsertPortfolioAccessMetadataResponse.  # noqa: E501
        :rtype: dict[str, lusid.MetadataKeyValueResponse]
        """
        return self._portfolios_with_metadata

    @portfolios_with_metadata.setter
    def portfolios_with_metadata(self, portfolios_with_metadata):
        """Sets the portfolios_with_metadata of this BatchUpsertPortfolioAccessMetadataResponse.

        The set of portfolios with the access control metadata  # noqa: E501

        :param portfolios_with_metadata: The portfolios_with_metadata of this BatchUpsertPortfolioAccessMetadataResponse.  # noqa: E501
        :type portfolios_with_metadata: dict[str, lusid.MetadataKeyValueResponse]
        """
        if self.local_vars_configuration.client_side_validation and portfolios_with_metadata is None:  # noqa: E501
            raise ValueError("Invalid value for `portfolios_with_metadata`, must not be `None`")  # noqa: E501

        self._portfolios_with_metadata = portfolios_with_metadata

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BatchUpsertPortfolioAccessMetadataResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BatchUpsertPortfolioAccessMetadataResponse):
            return True

        return self.to_dict() != other.to_dict()
